{                         UTIL.PAS

  Tss tiedostossa on pienimuotoisia, mutta hydyllisi aliohjelmia
  koko muun ohjelmiston kyttn.

  Kytss ovat aliohjelmat: Pieneksi, WriteNumber, RiittaakoMuisti,
                             Bug.
}

{ Aliohjelmalla muutetaan kaikki parametrina tulevassa merkkijonossa olevat
  isot kirjaimet pieniksi. Mys skandinaaviset vokaalit muutetaan.

  Algoritmi:  1) TOISTA:
                 A) jos kirjain on A-Z, niin ASCII-koodista lasketaan
                    pieni kirjain
                 B) jos kirjain on , niin Case-lauseella jokainen
                    muutetaan erikseen
                 Kunnes merkkijono kyty lpi

  Kutsuttavat aliohjelmat:
              Length(...);             TurboPascalissa mritelty
}
Procedure Pieneksi(Var Jono : AnyString);
Var  i : Integer;
Begin
  For i:=1 To Length(Jono) Do
    If Jono[i] In ['A'..'Z'] Then Jono[i]:=Chr(Ord(Jono[i])+32)
    Else Case Jono[i] Of
           '' : Jono[i]:='';
           '' : Jono[i]:='';
           '' : Jono[i]:='';
         End; { Case }
End; { Pieneksi }


{ Aliohjelmalla tarkistetaan, onko koneessa riittvsti vapaata muistia
  tarvittavien dynaamisten muuttujien ksittelyyn.

  Kutsuttavat aliohjelmat:
              Length(...);               TurboPascalissa mritelty
              SizeOf(...);               TurboPascalissa mritelty
              MaxAvail;                  TurboPascalissa mritelty
}
Function RiittaakoMuisti(Syotto : AnyString) : Boolean;
Begin
  RiittaakoMuisti:= (Length(Syotto) * (2 * SizeOf(Luku))) < MaxAvail;
End; { Riittaako Muisti }


{ Aliohjelmalla ilmoitetaan kyttjlle ohjelmasta lytyneest virheest
  ja palautetaan kyttjrjestelmlle virhekoodi.

  Kutsuttavat aliohjelmat:
              Halt(...);              TurboPascalissa mritelty
}
Procedure Bug ( ErrorText : AnyString);  { aliohjelman nimi tulee paramet- }
                                         { rissa ErrorText }
Begin
  WriteLn('You have found a BUG!'); WriteLn;
  WriteLn('Please contact the author of this program (suhonen@tukki.jyu.fi)');
  WriteLn('and explain things you have done. Thnx.');
  WriteLn('Bug found in routine ',ErrorText);
  Halt(1);
End; { bug }
